# NuVoteCoprocess.ps1 - starts a FileSystemWatcher for <kartinstall>/luafiles/ping.txt
# Prints the current time to <kartinstall>/luafiles/currentutc.txt when triggered
# 01/08/2024 - cglitcher
# This script file is hereby reusable.

# DISCLAIMER: Use this script at your own risk.
# 
# This script is provided as-is, without any express or implied warranties.
# The author(s) disclaim all liability for direct, indirect, or consequential damages
# resulting from your use of this script, including but not limited to loss of data or
# damage to your system. It is your responsibility to review and test the script
# to ensure it meets your requirements before using it in any production environment.
# 
# The author(s) make no guarantees regarding the accuracy, reliability, or 
# suitability of this script for any purpose. Use caution and exercise due diligence 
# when running scripts from untrusted sources.

################################
#     USAGE INSTRUCTIONS       #
################################

# 1. Place this file in your kart install folder (where srb2kart.exe resides)
# 2. Scroll through your newly created file, and make replacements for values as denoted by comments
#     * You'll need to make replacements for the following items
#     - $fileDir
#     - Value for Set-Content -Path
# 3. Add this script in your ps or bat script that launches kart:
#     - [powershell -File "C:\Path\to\NuVoteCoprocess.ps1"]
# 4. Close the shell running this script in order to stop
#     - Note: this program won't work if there are multiple instances of it

################################
#    END USAGE INSTRUCTIONS    #
################################

# Replace C:\Path\to\kartinstall\luafiles to the luafiles folder in your kart install folder
# Example: C:\Users\cglitcher\Games\SRB2Kart\luafiles
$fileDir = "C:\Path\to\luafiles"
$pingFile = "ping.txt"
$utcfile = "currentutc.txt"
$outFile = $fileDir + "\" + $utcfile
$watcher = New-Object System.IO.FileSystemWatcher
$watcher.Path = $fileDir
$watcher.Filter = $pingFile
$watcher.IncludeSubdirectories = $false
$watcher.EnableRaisingEvents = $true
# C:\Path\to\luafiles\currentutc.txt
echo $outFile
$action = { 
    $date = [long]((date).touniversaltime()-[datetime]'1970-01-01').totalseconds
    # Replace C:\Path\to\kartinstall\luafiles to the luafiles folder in your kart install folder.
    # KEEP the last bit - the file as is. Example of the full line below
    # Set-Content -Path "C:\Users\cglitcher\Games\SRB2Kart\luafiles\currentutc.txt" -Value $date
    Set-Content -Path "C:\Path\to\luafiles\currentutc.txt" -Value $date 
    }


Register-ObjectEvent $watcher "Changed" -Action $action

while ($true) {
    Start-Sleep -Seconds 1
}

# cg note: I tried many times to get $fileDir used in the Set-Content expression without success
# Not gonna try to debug in interest of time